.include "8515def.inc"        ;ggf. anpassen

.equ	Strobe	  = PB4		         ; Strobe 4094
.equ	D4094	   = PB5		         ; Daten fr 4094
.equ	CLK	     = PB7		         ; 4094 Clock
.equ BUSY     = PB6           ; MISO
.equ LCD_PORT = PORTB
.equ LCD_DIR  = DDRB

.equ ENABLE   = 0b00001000    ; LCD Enable
.equ RW       = 0b00000100    ; read , write
.equ RS       = 0b00000010    ; RS
.equ BL       = 0b00000001    ; 

.def temp1     = r16
.def temp2     = r17
.def temp3     = r18
.def data_4094 = r19
.def cnt       = r20
.def temp      = r21

.CSEG

           ldi temp1,0x02
           ldi temp2,0x5E
           out sph,temp1
           out spl,temp2
           in  temp1,mcucr
           cbr temp1,0x40
           out mcucr,temp1
           
           
           ldi temp1, 0b10111111    ;
           out LCD_DIR, temp1

;**********************************************************************************************
;* SPI nach Bedarf
;**********************************************************************************************
                                    ; init SPI
           ldi  temp1,0b01011100    ; SPIE = 0, SPE = 1, DORD = 0, MSTR = 1, CPOL = 1, CPHA = 1
                                    ; SPR1 = 0, SPR0 = 0
           out  SPCR, temp1
;**********************************************************************************************
           
           rcall lcd_init       ;Display initialisieren
           clr   temp	        ; Zeichen-Zhler
Ini1:
           mov   temp1,temp      ; Zeichen-Zhler als Zeichencode bertragen           
           rcall DefChar        ; das Zeichen fr diesen Zeichencode definieren
           inc   temp
           cpi   temp,8          ; ist es 8?
           brne  Ini1           ; Sprung, wenn nicht
haupt:
           ldi   temp1,$0C	; Display on, Cursor off, Blinken off
           rcall SendCom	; Befehl senden           
           rcall lcd_clear      ;Display lschen
           ldi   ZH,high(Text3)
           ldi   ZL,low(Text3)	; Z-Ptr zeigt auf Textanfang
           ldi   cnt,16	        ; Text hat 16 Zeichen
           rcall OutText	; gibt Text3 aus

           ldi   temp1,64	; Adr. = Beginn der 2. Zeile
           sbr   temp1,1<<7	; Bit7 setzen -> Ziel ist DD-RAM
           rcall SendCom	; setzt Adressenzeiger im DD-RAM
           ldi   ZH,high(Text4)
           ldi   ZL,low(Text4)	; Z-Ptr zeigt auf Textanfang
           ldi   cnt,16	        ; Text hat 16 Zeichen
           rcall OutText	; gibt Text4 aus
           ldi   temp1,64+5	; Adr. des 6. Zeichens in der 2. Zeile
           sbr   temp1,1<<7	; Bit7 setzen -> Ziel ist DD-RAM
           rcall SendCom	; setzt Adressenzeiger im DD-RAM
           ldi   temp1,$0D	; Display on, Cursor off, blinkt
           rcall SendCom	; Befehl senden
           rcall Wait5s	        ; 5 Sekunden warten
           ldi   temp1,$14	; Cursor nach rechts schieben
           rcall SendCom	; Befehl senden
           rcall Wait5s	        ; 5 Sekunden warten
           ldi   temp1,$14	; Cursor nach rechts schieben
           rcall SendCom	; Befehl senden
           rcall Wait5s	        ; 5 Sekunden warten

TestCursor:
           ldi   temp1,$0E	; Display on, Cursor on, Blinken aus
           rcall SendCom	; Befehl senden
           ldi   temp1,64	; Adr. = Beginn der 2. Zeile
           sbr   temp1,1<<7	; Bit7 setzen -> Ziel ist DD-RAM  
           rcall SendCom	; setzt Adressenzeiger im DD-RAM
           ldi   ZH,high(Text5)
           ldi   ZL,low(Text5)	; Z-Ptr zeigt auf Textanfang
           ldi   cnt,16	        ; Text hat 16 Zeichen
           rcall OutText	; gibt Text5 aus
           ldi   temp1,64+1	; Adr. des 2. Zeichens in 2. Zeile
           sbr   temp1,1<<7	; Bit7 setzen -> Ziel ist DD-RAM

           rcall SendCom	; setzt Adressenzeiger im DD-RAM
           rcall Wait5s	        ; 5 Sekunden warten

Sonderzeichen:
           rcall lcd_clear      ;Display lschen
           ldi   temp1,$0C	; Disp. on, Cursor off, Blinken off
           rcall SendCom	; Befehl senden
           ldi   ZH,high(Text1)
           ldi   ZL,low(Text1)	; Z-Ptr zeigt auf Textanfang
           ldi   cnt,16	        ; Text hat 16 Zeichen
           rcall OutText	; gibt Text1 aus
           ldi   temp1,64	; Adr. = Beginn der 2. Zeile
           sbr   temp1,1<<7	; Bit7 setzen -> Ziel ist DD-RAM
           rcall SendCom	; setzt Adressenzeiger im DD-RAM
           ldi   ZH,high(Text2)
           ldi   ZL,low(Text2)	; Z-Ptr zeigt auf Textanfang
           ldi   cnt,16	        ; Text hat 16 Zeichen
           rcall OutText	; gibt Text2 (8 Sonderzeichen) aus
           rcall Wait5s         ; 5 Sekunden warten
           rcall Wait5s         ; 5 Sekunden warten
           rjmp  Haupt          ; Endlosschleife




.include "lcd-routines.asm"            ;LCD-Routinen werden hier eingefgt
